#!/usr/bin/perl
use warnings;
use strict;
use File::Basename;
use Getopt::Std;

my %opt;
getopts("hm:", \%opt);

if (@ARGV == 0 || $opt{h}) {
  print "usage: ", basename($0), " [options] file(s)...\n\n";
  print "Options:\n";
  print "  -m NUMBER       maximum chars tolerated per line\n";
  print "  -h              this help\n";
  exit 0;
}

my $max = 80;
my $line = 0;

$max = $opt{m} if ($opt{m});

for my $file (@ARGV) {
  open FILE,"<", $file;
  $line = 0;
  while (<FILE>) {
    $line++;
    if (length > $max) {
      print "\"$file\" - line $line: ", length, " chars\n";
    }
  }
}
