#!/usr/bin/perl
use warnings;
use strict;
use File::Basename;

if (@ARGV != 2) {
  print "usage: ", basename($0), " <regexp> <string>\n";
  exit 2;
}

my $string = $ARGV[1];
my $pattern = $ARGV[0];

if ($string =~ /$pattern/) {
  print "\e[0;32mmatches:\e[0m $&\n";
  exit 0;
} else {
  print "\e[0;31mno match\e[0m\n";
  exit 1;
}
