#!/bin/sh
#----------------------------------------------------
# Version:      0.1.0
# Author:       Florian "Bluewind" Pritz <flo@xssn.at>
#
# Licensed under WTFPL v2
#   (see COPYING for full license text)
#
#----------------------------------------------------
# Easier mount remote folders over ssh
#----------------------------------------------------
if [ "$1" = "" ] || [ "$1" = "-h" ]; then 
 echo -e "${blue}Usage:$NC ssh-mount <server>";
 echo -e "${green}Servers:$NC wf, nevera-web, nevera-flo, df";
 exit 1
else
	case $1 in
		nevera-flo)
      DIR="/mnt/nevera/flo"
      mkdir -p "${DIR}"
			sshfs flo@nevera: -o reconnect -p 22222 "${DIR}" &&
			echo -e "${GREEN}Nevera: /home/flo mounted.$NC"
		;;
    nevera-web)
      DIR="/mnt/nevera/web"
      mkdir -p "${DIR}"
			sshfs web0@nevera: -o reconnect -p 22222 "${DIR}" &&
			echo -e "${GREEN}Nevera: web mounted.$NC"
		;;
    df)
      DIR="/mnt/df_ssh"
      mkdir -p "${DIR}"
			sshfs 105012-ftp@seitznet2.at: -p 22 "${DIR}" &&
			echo -e "${GREEN}DF mounted.$NC"
		;;
		wf)
      DIR="/mnt/wf_ssh"
      mkdir -p "${DIR}"
			sshfs stem47@stem47.loomes.net: -o reconnect -p 22 "${DIR}" &&
			echo -e "${GREEN}WF mounted.$NC"
		;;
		*)           echo -e "${RED}Error:$NC Unknown Server" ;;
	esac
 
fi
